// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <cstdio>
#include <ClanLib/clanlayer2.h>

#include "actions/pingu_actions.hh"
#include "ActionButton.hh"

//CL_Font* Button::font;
//CL_Surface* Button::button_p;

ActionButton::ActionButton(int x, int y, string str)
{
  //  make_action = func;
  x_pos = x;
  y_pos = y;
  name = str;
  //  button_p = CL_Res_Surface::load(str, *resource);
  button   = CL_Res_Surface::load("Buttons/empty", *resource());
  font = CL_Res_Font::load("Fonts/smallfont_h",*resource());
  if (str != "empty") {
    action   = CL_Res_Surface::load(("Buttons/" + str).c_str(),
				    *resource());
    action_c.set_size(action->get_no_sprs());
    action_c.set_speed(50);
  } else {
    action = 0;
  }
}

bool
ActionButton::is_pressed()
{
  return false;
}

void
ActionButton::draw()
{
  if (is_pressed())
    // BUG: Should use button_p
    // remmed, because of speed
    button->put_screen(x_pos, y_pos); 
  else
    button->put_screen(x_pos, y_pos);

  if (action) {
    action->put_screen(x_pos + 3, y_pos + 20, action_c);
  }
  font->print_center(x_pos + 25, y_pos + 5, "99");
}

void
ActionButton::let_move()
{
  ++action_c;
}

/*
PinguAction*
ActionButton::get_action()
{
  return make_action();
} */

string
ActionButton::get_action_name()
{
  return name;
}

/* EOF */
