// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <iostream>
#include <cstdio>
#include <cassert>

#include "globals.hh"
#include "Pingu.hh"
#include "Pingu.hh"
#include "CaptureRectangle.hh"

CL_Surface* CaptureRectangle::good; 
CL_Surface* CaptureRectangle::bad; 

Pingu* CaptureRectangle::current_pingu; 
PinguAction* CaptureRectangle::button_action;

CaptureRectangle::CaptureRectangle()
{

} 

CaptureRectangle::~CaptureRectangle()
{
}

void
CaptureRectangle::draw_offset(int x_offset, int y_offset, float s)
{ 
  if (!current_pingu) {
    return;
  } else {
    CL_Surface* sur;
    
    if (button_action->get_environment() & current_pingu->get_environment()) {
      sur = good;
    } else {
      sur = bad;
    }
    
    if (s == 1.0) {
      sur->put_screen(current_pingu->get_x() + current_pingu->x_offset() + x_offset - 1,
		      current_pingu->get_y() + current_pingu->y_offset() + y_offset - 1);
    } else {
      sur->put_screen(int(current_pingu->get_x() + current_pingu->y_offset() + x_offset * s) - 1,
		      int(current_pingu->get_y() + current_pingu->y_offset() + y_offset * s) - 1,
		      s, s);
    }
  }
}


void 
CaptureRectangle::set_action(PinguAction* ac)
{
  button_action = ac;
}

void
CaptureRectangle::set_pingu(Pingu* pingu)
{
  current_pingu = pingu; 
}

void
CaptureRectangle::load_data()
{
  good = CL_Res_Surface::load("Cursors/capgood", *resource());
  bad  = CL_Res_Surface::load("Cursors/capbad",  *resource()); 
}  
/* EOF */

