// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef CLIENT_HH
#define CLIENT_HH

#include <string>

#include "Server.hh"
#include "Result.hh"
#include "PingusMusic.hh"

class Client
{
public:
private:
  Server* server;
  PingusMusic*     music;
  PingusGameMode       mode;
  bool fast_forward;
  int skip_frame;
  //  vector<View>    view;
public:
  Client(Server* s);
  Result start(string filename, PingusGameMode m);
  Result play_level(string filename);
  void toggle_fast_forward();
};

#endif

/* EOF */
