// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef PINGUSMENU_HH
#define PINGUSMENU_HH

#include <ClanLib/clanlib.h>

#include "GameObj.hh"

class PingusMenu : public GameObj
{
public:
  enum PingusMenuItem { pmiSTART, pmiLOAD, pmiQUIT, pmiVOID };
private:
  CL_Surface* start;
  CL_Surface* load;
  CL_Surface* quit;
  CL_Surface* highlight;
  CL_Surface* bg;

  int start_x, start_y;
  int load_x, load_y;
  int quit_x, quit_y;
  PingusMenuItem current_item;
public:
  PingusMenu();
  ~PingusMenu();
  void draw(void);
  PingusMenuItem select(void);
  
};

#endif

/* EOF */
